require 'test/unit'
require 'fluent/test/driver/parser'
require 'fluent/plugin/parser_gzip'

class ParserYourOwnTest < Test::Unit::TestCase
  def setup
  end
  CONFIG = %[
    pattern apache
  ]
  def create_driver(conf = CONF)
    Fluent::Test::Driver::Parser.new(Fluent::Plugin::GzipParser).configure(conf)
  end
  sub_test_case 'configured with invalid configurations' do
    test 'empty' do
      assert_raise(Fluent::ConfigError) do
        create_driver('')
      end
    end
  end
  sub_test_case 'plugin will parse text' do
    test 'record has a field' do
      d = create_driver(CONFIG)
      text = '192.168.0.1 - - [28/Feb/2013:12:00:00 +0900] "GET / HTTP/1.1" 200 777'
      expected_time = event_time('28/Feb/2013:12:00:00 +0900', format: '%d/%b/%Y:%H:%M:%S %z')
      expected_record = {
      'method' => 'GET',
      }
      d.instance.parse(text) do |time, record|
        assert_equal(expected_time, time)
        assert_equal(expected_record, record)
      end
    end
  end
end
